#ifndef MAIN_WINDOW_H
#define MAIN_WINDOW_H

#include <QWidget>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QDialogButtonBox>
#include <QListWidget>
#include <QLabel>
#ifdef ENABLE_HOLDER
#include <QSharedMemory>
#endif

#include "setrans.h"

#ifndef Q_NULLPTR
#define Q_NULLPTR 0
#endif

#ifndef QStringLiteral
typedef QLatin1String QStringLiteral;
#endif

typedef QMap<int,int> SCategories;

class MainWindow: public QWidget
{
    Q_OBJECT
public:
    MainWindow(QWidget *parent = Q_NULLPTR);
    ~MainWindow();

    void setRange(const QString&);
    QString range();

private:
    QHBoxLayout *l_hlayout1;
    QHBoxLayout *l_hlayout2;
    QHBoxLayout *l_hlayout3;
    QVBoxLayout *l_vlayout1;
    QLabel *w_info;
    QLabel *w_current_range;
    QLabel *w_message;
    QListWidget *w_levels;
    QListWidget *w_categories;
    QDialogButtonBox *w_buttonbox;

    int m_level_min;
    int m_level_max;
    int m_level_cur;
    SCategories m_categories;
#ifdef ENABLE_HOLDER
    QString m_key_path;
    QSharedMemory *m_shmem;
#endif
    Setrans m_setrans;

    void applyGuiRange();

private Q_SLOTS:
    void levelClicked(QListWidgetItem*, QListWidgetItem*);
    void categoriesSelected();
    void buttonPressed(bool);
    void apply();
};

#endif
