
#include <selinux/selinux.h>

#include "setrans.h"

Setrans::Setrans()
    : SetransBase()
{
}

Setrans::~Setrans()
{
}

SetransEntry Setrans::tr(const QString &in)
{
    SetransEntry ret(value(in, {QString(), QColor(Qt::black), QColor(Qt::white)}));
    if( ret.tr.isEmpty() ) {
	seTranslate(in);
	ret = value(in, {QString(), QColor(Qt::black), QColor(Qt::white)});
    }
    if( ret.tr.isEmpty() ) {
	ret = {in, QColor(Qt::darkGray), QColor(Qt::lightGray)};
    }
    return ret;
}


void  Setrans::seTranslate(const QString &in)
{
    char *btrans;
    if (selinux_raw_to_trans_context(QByteArray(":::").append(in.toLatin1()).data(), &btrans) == 0)
    {
	insert(in, {QString::fromUtf8(btrans + 3), QColor(Qt::black), QColor(Qt::white)});
	freecon(btrans);
    }
}
